SystemOrganization addCategory: #ManifestoBrowser!

TestCase subclass: #ManifestoBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowserTest methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:27'!
packageName
	^ 'ManifestoBrowser'! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/28/2011 14:25'!
testHasManisfesto

	| aPackage browser |
	browser := ManifestoBrowser new.

	aPackage := (RPackageOrganizer default packageNamed: self packageName).
	self assert: (browser hasManisfesto: aPackage).

	aPackage := (RPackageOrganizer default packageNamed: 'Kernel-Classes').
	self deny: (browser hasManisfesto: aPackage).
! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/28/2011 14:25'!
testManisfestoName

	| browser aPackage |
	browser := ManifestoBrowser new.
	aPackage := RPackageOrganizer default packageNamed: 'Kernel-Classes'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoKernelClasses'.
	
	aPackage := RPackageOrganizer default packageNamed: 'Announcements-Tests-Core'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoAnnouncementsTestsCore'! !

Object subclass: #ManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowser class methodsFor: 'public' stamp: 'AngelNunez 9/28/2011 13:43'!
open
	"Open a browser"
	^ self new open! !

!ManifestoBrowser methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:20'!
hasManisfesto: aPackage
	"this should be an extension method dfined on the class RPackage"
	
	| manisfestoName |
	manisfestoName := self manifestoNameOf: aPackage.
	^ aPackage classes anySatisfy: [ :aClass | aClass name = manisfestoName ]! !

!ManifestoBrowser methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:20'!
manifestoNameOf: aPackage

	^ 'Manifesto', (aPackage name copyWithout: $-)! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 9/28/2011 14:06'!
open
	"
	self new open
	"

	^ self openOn: self sortedPackages! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 9/28/2011 14:12'!
openOn: aPackageList
	"
	self new open
	"
	| browser |
	
	browser := GLMTabulator new.
	browser 
		column: #packages; 
		column: #manisfesto.
	
	browser transmit to: #packages; andShow: [ :a | a list format: #name ].
	
	browser transmit 
		when: [ :aPackage | self hasManisfesto: aPackage ];
		to: #manisfesto; 
		from: #packages; 
		andShow: [ :a |
		a list display: [ :x | 
			#('authors' 'lint rules')
			].
	].
	browser openOn: aPackageList! !

!ManifestoBrowser methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:06'!
sortedPackages
	^ RPackageOrganizer default packages asSortedCollection: [ :a :b | a name <= b name ]! !

Object subclass: #ManifestoManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!
